#include "pch.h"
#include "SAMessenger.h"
#include "SAInstSDKUserSample.h"
#include "SAInstSDKUserSampleDlg.h"

void SAMessenger::CollectionGroupTargetNamesFromSA(std::string c, std::string g, std::string t)
{
	TRACE("CollectionGroupTargetNamesFromSA, c=%s, g=%s, t=%s\n", c.c_str(), g.c_str(), t.c_str());
}

bool SAMessenger::BeginMeasureMessageFromSA()
{
	TRACE("BeginMeasureMessageFromSA received\n");
	return true;
}
bool SAMessenger::StopMeasureMessageFromSA()
{
	TRACE("StopMeasureMessageFromSA received\n");
	return true;
}

bool SAMessenger::BatchMeasPointsFromSA(std::vector<std::string> c, std::vector<std::string> g, std::vector<std::string> t, std::vector<SAvector> nomPt)
{
	CSAInstSDKUserSampleDlg& d = *((CSAInstSDKUserSampleDlg*)theApp.m_pMainWnd);

	TRACE("BatchMeasPointsFromSA:\n");
	std::vector<SAxform> xforms; // if we don't populate this, then we just send an empty vector in SendBatchofPtstoSA, and the batch is interpretted as 3D
	// OR we can populate the xform vector, and the batch will be interpretted as 6D
	//std::vector<SAxform> xforms(nomPt.size());
	//for (INT_PTR i = 0; i < nomPt.size(); i++)
	//{
	//	SAvector rot;
	//	rot.x = 3.0;
	//	rot.y = 1.5;
	//	rot.z = (double)i*3.0;
	//	TRACE(" pt %d, c::g::t = %s::%s::%s, nomXYX = %f, %f, %f, fixedXYZ Rotation: %f, %f, %f\n", 
	//		i, c[i].c_str(), g[i].c_str(), t[i].c_str(), nomPt[i].x, nomPt[i].y, nomPt[i].z, rot.x, rot.y, rot.z);
	//	xforms[i] = d.sa.SetFromOriginAndFixedRxyzDegrees(nomPt[i], rot);
	//}
	//TRACE("\n");

	std::vector<SAvector> sigmas(nomPt.size());
	for (INT_PTR i = 0; i < nomPt.size(); i++)
	{
		sigmas[i].x = 0.001;
		sigmas[i].y = 0.002;
		sigmas[i].z= 0.003;
	}

	std::vector<std::string> notes;
	//std::vector<std::string> notes(3);
	//notes[0] = "This is a 6D point.";
	//notes[1] = "You can construct a frame from";
	//notes[2] = "its Measurement Probing Frame in SA";

	d.sa.SendBatchofPtsToSA(nomPt, xforms, sigmas, c, g, t, 0.125, 0.125, notes);
	
	return true;
}

bool SAMessenger::OpCheckCommandFromSA(std::string command)
{
	TRACE("OpCheckCommandFromSA received, command = %s\n", command.c_str());
	return true;
}